/*
 *  The MIT License
 * 
 *  Copyright 2011-2012 Masahiko, SAWAI <masahiko.sawai@gmail.com>.
 * 
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 * 
 *  The above copyright notice and this permission notice shall be included in
 *  all copies or substantial portions of the Software.
 * 
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 *  THE SOFTWARE.
 */
package com.example.hello.android.appwidget_time_update;

import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.Context;
import android.util.Log;
import android.widget.RemoteViews;
import java.util.Random;

/**
 *
 * @author sawai
 */
public class HelloAppWidgetProvider extends AppWidgetProvider
{

	private static final String LOG_TAG = "HelloAppWidgetProvider";

	public HelloAppWidgetProvider()
	{
		Log.d(LOG_TAG, "HelloAppWidgetProvider() : Hello");
		Log.d(LOG_TAG, "HelloAppWidgetProvider() : Bye");
	}

	@Override
	public void onEnabled(Context context)
	{
		Log.d(LOG_TAG, "onEnabled() : Hello");
		super.onEnabled(context);
		Log.d(LOG_TAG, "onEnabled() : Bye");
	}

	@Override
	public void onDisabled(Context context)
	{
		Log.d(LOG_TAG, "onDisabled() : Hello");
		super.onDisabled(context);
		Log.d(LOG_TAG, "onDisabled() : Bye");
	}

	@Override
	public void onUpdate(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds)
	{
		Log.d(LOG_TAG, "onUpdate() : Hello");

		String[] names = context.getResources().getStringArray(R.array.names);
		String hello = context.getString(R.string.hello);
		Random random = new Random();

		for (int appWidgetId : appWidgetIds)
		{
			Log.d(LOG_TAG, "onUpdate() : appWidgetId => " + appWidgetId);
			String name = names[random.nextInt(names.length)];
			RemoteViews remoteViews = new RemoteViews(context.getPackageName(), R.layout.hello_appwidget);
			String message = hello + ", " + name;
			remoteViews.setTextViewText(R.id.message_textview, message);
			appWidgetManager.updateAppWidget(appWidgetId, remoteViews);
		}

		Log.d(LOG_TAG, "onUpdate() : Bye");
	}

	@Override
	public void onDeleted(Context context, int[] appWidgetIds)
	{
		Log.d(LOG_TAG, "onDeleted() : Hello");
		for (int i = 0; i < appWidgetIds.length; i++)
		{
			Log.d(LOG_TAG, "onDeleted() : appWidgetIds[" + i + "] => " + appWidgetIds[i]);
		}
		Log.d(LOG_TAG, "onDeleted() : Bye");
	}
}
